**********************************************************************
*
* ( ZZ.PRG ) - The main program of SalesBridge
* Contains foundation read which calls the menus and other routines.
*
* Original SalesBridge-dBase(tm), Clipper(tm) and FoxPro(tm) for DOS
* programs re-written for FoxPro 2.5 for Windows with windowing routines
* in zzProc.prg adapted from FoxPro examples and:
*
* Inside FoxPro 2.5 For Windows
* by Bob Grommes
* 1993, New Riders Publishing
* ISBN # 1-56205-178-4
* 
* All SalesBridge programs and routines may be modified or copied
* for use by one company for internal use ONLY. Any other use must be
* approved by Patrick Smith at Contact Technology
* prior to development and release. If you have any ideas or spinoffs
* to this program, let me know!
*
* "SalesBridge Copyright (c) 1989, 1990, 1992, 1995 Contact Technology
* Send correspondance to:
*
* shasta@crl.com
* ashasta@aol.com
* 76233,1607@compuserve.com
*
* For more information, see the file ReadMe.1st, the "About"
* Help menu selection, and SalesBridge help screens
*
**********************************************************************

* Top level loop created so program can re-start itself
* if necessary.

*-----------
DO WHILE .T.
*-----------

  SET TALK OFF
  CLEAR PROG
  CLEAR ALL
  CLEAR MEMO
  CLOSE DATA

  * Save system SETtings and set them the way we like.
  PUBLIC cSetBell,cSetDelete,cSetCent,cSetExcl,cSetEscape,cStatusBar,cReadBorder
  cSetBell   = SET('BELL')
  SET BELL OFF
  cSetDelete = SET('DELETE')
  SET DELETE ON
  cSetCent   = SET('CENTURY')
  SET CENTURY ON
  cSetExcl   = SET('EXCLUSIVE')
  SET EXCLUSIVE OFF
  cSetEscape = SET('ESCAPE')
  SET ESCAPE ON
  cStatusBar = SET('STATUS BAR')
  SET STATUS BAR OFF
  cReadBorder = SET('READBORDER')
  SET READBORDER ON

  * Main procedure library, all called procedures are here
  * or in the file where the calling procedure resides
  SET PROCEDURE TO zzProc

  * Initialize global memvars, dbfs indexes .......
  DO Init in zzInit

  * Set the title of the Main Window.
  * _SerNum is taken from zzData.dbf in proc zzInitx of zzInit.prg
  * Gives 2 ways to display main menu window header
  DO CASE
  CASE SUBSTR(_SerNum,5,4) = 'SB57'
    _SBTitle = 'SalesBridge 3.1b -  '
  OTHERWISE
    _SBTitle = 'SalesBridge 3.1b Demo  -  '
  ENDCASE
  
  MODIFY WINDOW SCREEN ;
    TITLE _SBTitle + _Title ;
    ICON FILE zz.ico

  IF .NOT. m._bshutdown
    * Define the system menu bar for this application.
    PUSH MENU _MSYSMENU
  ENDIF

  * Check for existance of work files directory, create if necessary
  * I hear foxtools has a better way of doing this but I havn't
  * had time to experiment!
  * Create a "C:/sbr" on every local drive to reduce net traffic!
  * I store screen info to .mem files in this DIR
  IF NOT FILE('c:\sbr\NUL')
     WAIT 'Creating SalesBridge Work Directory.....' WINDOW TIMEOUT 2
     RUN /256 workdir
  ENDIF

  * Loop with foundation read, exit loop to quit/restart
  *---------------
  GetMenu = .t.
  DO WHILE GetMenu

    _SvWall = _Wall    && save wallpaper in case of change

    IF .NOT. m._bshutdown
      DO zzMenu.mpr

      * Define a dummy window for the foundation READ to sit in
      * so the Main FoxPro Window will still be re-sizable.
      DEFINE WINDOW fake_desk_ AT -5,-5 SIZE 1,1 NONE
      ACTIVATE WINDOW fake_desk_ NOSHOW

      * Foundation READ
      READ VALID wDispatch()

    ENDIF

    IF _Wall <> _SvWall OR _ReStart && if wallpaper changed, re-start program
     GetMenu   = .F.
     _bQuitFox = .F.
     x_choice  = 0
     LOOP
    ENDIF

    IF m._bShutdown AND _Wall = _SvWall
      DEFINE WINDOW PrgQuit ;
        AT 4,7 ;
        SIZE 6,70 ;
        TITLE  'Quit SalesBridge?' ;
        FONT 'Times New Roman', 10 ;
        STYLE 'B' ;
        FLOAT ;
        CLOSE ;
        NOMINIMIZE ;
        DOUBLE
      MOVE WINDOW PrgQuit CENTER
      ACTIVATE WINDOW PrgQuit

      @ 0.846,2.667 SAY (LOCFILE("exclaim.bmp","BMP|ICO", "Where is exclaim.bmp?")) BITMAP ;
        SIZE 3.385,7.833 ;
        STYLE "T"

      @  1,14 SAY 'Quit SalesBridge?' ;
         FONT 'Times New Roman',10 ;
         STYLE 'B'
      x_choice = 1
      @  3,14 get x_Choice picture '@*H  OK ; \?Cancel ; Exit To FoxPro ' ;
         SIZE 2,20,1 ;
         FONT 'Times New Roman',10

      READ

      DEACTIVATE WINDOW PrgQuit

      DO CASE
      CASE x_Choice = 2
        m._bshutdown = .F.
        LOOP
      CASE x_Choice = 1 .or. x_Choice = 3 .or. _bQuitFox
        GetMenu = .F.
        TopLoop = .F.
        EXIT
      OTHERWISE
        GetMenu = .F.
        TopLoop = .F.
        EXIT
      ENDCASE

    ENDIF { m_bShutDown }

  ENDDO { getmenu }
  
  IF x_Choice = 1 OR x_Choice = 3 OR _bQuitFox
    EXIT
  ENDIF

ENDDO { .T. }

* Restore SET setting that we changed. This is only done once at
* program exit, so we don't mind the small extra overhead of using
* macros to make the code look a little better.
SET BELL &cSetBell
SET DELETE &cSetDelete
SET CENTURY &cSetCent
SET EXCLUSIVE &cSetExcl
SET ESCAPE &cSetEscape
SET STATUS BAR &cStatusBar
SET READBORDER &cReadBorder

* If we exited as a result of ON SHUTDOWN, quit foxpro now.
DO CASE
CASE x_Choice = 3
  *  clear menus, memvars, screens, restore settings
  DO zzShutDn
  CANCEL
CASE _bQuitFox .or. x_Choice = 1
  *  clear menus, memvars, screens, restore settings
  DO zzShutDn
  ON SHUTDOWN
  QUIT
OTHERWISE
  *  clear menus, memvars, screens, restore settings
  DO zzShutDn
  CANCEL
ENDCASE

RETURN

*************************************************************
*************************************************************
* EOF - ZZ.prg
*************************************************************
*************************************************************

