*********************************************************************
* zzAlert.prg
*
* ZZALERT will place a Mac-style alert box on the
* screen with a multi-line message and optional
* buttons.
*
* Adapted from Inside Foxpro 2.5
*********************************************************************

PARAMETERS cType,cWait,nRow,nCol,cMsg1,cMsg2,;
           cMsg3,cMsg4

PRIVATE bOWVis,bUserButs,cBlink,cButton,cDevice,;
        cHotKeys,cReturn,cScheme21,cWinSave,;
        nButtons,nButDef,nButWidth,nIconLen,;
        nOffset,nParms,nScheme,nTextLen,nTextLns,;
        nTime,nWhat,nWinWidth,n,nHgtFact,nWidFact,;
        nButFact,nOneBut,c,cBFont,nBSize,cBStyle,;
        cWFont,nWSize,cWStyle,cButMsg,cStripCtrl

nParms = PARAMETERS()
RELEASE WINDOW alert
cWinSave = WOUTPUT()
bOWVis = WVISIBLE(cWinSave)
cType = UPPER(ALLTRIM(cType))
cDevice = SET('DEVICE')
cScheme21 = SCHEME(21)

* The button font
cButton = ''
cBFont = 'MS Sans Serif'
nBSize = 10

* The alert window font
cBStyle = 'B'
cWFont = 'FixedSys'
nWSize = 10
cWStyle = 'N'

IF _WINDOWS
  PRIVATE nMWFHeight,nAFHeight
  * Height of the main window font
  nMWFHeight = FONTMETRIC(1,WFONT(1,''),;
                            WFONT(2,''),;
                            WFONT(3,'')) ;
             + FONTMETRIC(5,WFONT(1,''),;
                            WFONT(2,''),;
                            WFONT(3,''))
  * Height of the alert window font
  nAFHeight  = FONTMETRIC(1,cWFont,nWSize,cWStyle) ;
             + FONTMETRIC(5,cWFont,nWSize,cWStyle)
  * Ratio of alert window font height
  * to main window font height
  nHgtFact = nAFHeight / nMWFHeight
  * Ratio of alert window font width
  * to main window font width
  nWidFact = FONTMETRIC(6,cWFont,nWSize,cWStyle) ;
           / FONTMETRIC(6,WFONT(1,''),;
                          WFONT(2,''),;
                          WFONT(3,''))
  * Ratio of button font width
  * to alert window font width
  nButFact = FONTMETRIC(6,cBFont,nBSize,cBStyle) ;
           / FONTMETRIC(6,cWFont,nWSize,cWStyle)
  nSpaceLen = TXTWIDTH(' ',cBFont,nBSize,cBStyle) ;
            * nButFact
ELSE
  STORE 1 TO nHgtFact,nWidFact,nButFact,nSpaceLen
ENDIF

* Calculate window width (height is always 7)

* For starters, get length of longest msg line

IF nParms > 4
  nTextLen = TXTWIDTH(cMsg1) * nWidFact
ENDIF

IF nParms > 5
  nTextLen = MAX(nTextLen,TXTWIDTH(cMsg2) * nWidFact)
ENDIF

IF nParms > 6
  nTextLen = MAX(nTextLen,TXTWIDTH(cMsg3) * nWidFact)
ENDIF

IF nParms = 8
  nTextLen = MAX(nTextLen,TXTWIDTH(cMsg4) * nWidFact)
ENDIF

nTextLns = nParms - 4
nIconLen = IIF(_DOS,11,8)
bUserButs = .f.
DIMENSION cButton[3],cButMsg[3]

IF NOT EMPTY(cWait)
  
  * Figure out response buttons and space required
  
  nButDef = 1
  DO CASE
    CASE cWait = 'OK'
      nButtons = 1
      cButton[1] = '\!Ok'
      cButMsg[1] = 'Ok'
    CASE cWait = 'C'
      nButtons = 1
      cButton[1] = '\!Continue'
      cButMsg[1] = 'Continue'
    CASE LEFT(UPPER(cWait),2) = 'YN'
      nButtons = 2
      cButton[1] = '\<Yes'
      cButMsg[1] = 'Yes'
      cButton[2] = '\<No'
      cButMsg[2] = 'No'

      IF UPPER(cWait) = 'YNC'
        nButtons = 3
        cButton[3] = '\<Cancel'
        cButMsg[3] = 'Cancel'
      ENDIF

      DO CASE
        CASE 'Y' $ cWait
          cButton[1] = '\!\<Yes'
        CASE 'N' $ cWait
          cButton[2] = '\!\<No'
          nButDef = 2
        CASE 'C' $ cWait
          cButton[3] = '\!\<Cancel'
          nButDef = 3
      ENDCASE
    OTHERWISE
    
      * User-defined buttons
    
      nButtons = OCCURS(';',cWait) + 1
      bUserButs = .t.
  ENDCASE
  
  IF bUserButs
    
    * Width of user func spec less all special
    * control characters (!,<,\ and ?) plus 1
    * space between each button plus the brackets
    * surrounding each button (if DOS)

    * With of widest button times # of buttons plus
    * space between each button (if Windows)

    cStripCtrl = STRTRAN(STRTRAN(STRTRAN(STRTRAN(cWait,'!'),'<'),'\'),'?')
    
    IF _WINDOWS
      nOneBut = 0
      DO WHILE ';' $ cStripCtrl
        nOneBut = MAX(nOneBut,TXTWIDTH(LEFT(cStripCtrl,AT(';',cStripCtrl) - 1),;
                  cBFont,nBSize,cBStyle) * nButFact)
        cStripCtrl = SUBSTR(cStripCtrl,AT(';',cStripCtrl) + 1)
      ENDDO
      nOneBut = MAX(nOneBut,(TXTWIDTH(cStripCtrl,cBFont,nBSize,cBStyle) ;
                  * nButFact))
      nButWidth = (nOneBut * nButtons) + (nSpaceLen * (nButtons - 1))
    ELSE
      nButWidth = LEN(STRTRAN(cStripCtrl,';')) ;
                + ((nButtons - 1) + (nButtons * 2))
    ENDIF
    
    * Determine the default button, if any --
    * otherwise default is 1st button
    
    IF '\!' $ cWait
      nButDef = OCCURS(';',LEFT(cWait,;
        AT('\!',cWait) - 1)) + 1
    ENDIF

  ELSE
    IF _WINDOWS
      nOneBut = 0

      FOR n = 1 TO nButtons
        nOneBut = MAX(nOneBut,TXTWIDTH(cButMsg[n],cBFont,nBSize,cBstyle) * nButFact)
      ENDFOR

      nButWidth = (nOneBut * nButtons) + (nSpaceLen * (nButtons -  1))
    ELSE
      nButWidth = 0

      FOR n = 1 TO nButtons
        nButWidth = nButWidth + LEN(cButMsg[n]) + 2
      ENDFOR

      nButWidth = nButWidth + (nButtons - 1)
    ENDIF

  ENDIF  

ELSE
  STORE 0 TO nButWidth,nOneBut
ENDIF

* Window width is icon width + greater of widest
* text line or length of the row of buttons, plus
* allowance for window border and whitespace around
* icon.

nWinWidth = nIconLen + MAX(nButWidth,nTextLen) + 5

* Calculate window position

IF nRow = -1
  nRow = ROUND((SROWS() / 2) - (3.5 * nHgtFact),0) - 1
ENDIF

IF nCol = -1
  nCol = ;
    ROUND((SCOLS() / 2) - ((nWinWidth * nWidFact) / 2),0) - 1
ENDIF

* Set up colors

nScheme = 21

DO CASE
  CASE _WINDOWS
    * We don't mess with colors in Windows
    nScheme = 5
  CASE cType = 'STOP'
  
    IF ISCOLOR()
    
      * Bright white on Red background
    
      SET COLOR OF SCHEME 21 TO ;
        W+/R,R/W,W+/R,GR+/R,W/R,W+/G,BG+/R,;
        N+/N,GR+/R,R+/B,+
    ELSE
    
      SET COLOR OF SCHEME 21 TO ;
        N/W,W+/N,N/W,W+/W,N/W,W/N,W/N,N+/N,;
        N+/W,W+/N,-
    
    ENDIF
  
  CASE cType = 'CAUTION'

    IF 'EGA' $ SYS(2006) OR 'VGA' $ SYS(2006)
    
      * Permit yellow background for caution
    
      cBlink = SET('BLINK')

      IF cBlink <> 'OFF'
        SET BLINK OFF
      ENDIF

      SET COLOR OF SCHEME 21 TO N/GR*,GR+/N,R/GR*,;
        GR/GR*,W/GR*,GR+/B,G/GR*,N+/N,R/GR*,BG+/GR*,+
    ELSE
    
      IF ISCOLOR()
      
        * CGA can't do yellow background, so it's
        * yellow letters on red background
      
        SET COLOR OF SCHEME 21 TO GR+/R,R/W,W+/R,;
          GR+/R,W/R,W+/G,BG+/R,N+/N,GR+/R,R+/R,+
      ELSE
      
        SET COLOR OF SCHEME 21 TO ;
          W+/N,W+/N,N/W,W+/W,N/W,W/N,W/N,N+/N,;
          W+/N,W+/N,-
      
      ENDIF
    ENDIF

  OTHERWISE
    * Modal dialog color
    nScheme = 5
ENDCASE

IF _DOS
  DEFINE WINDOW alert COLOR SCHEME (nScheme) ;
    FROM nRow,nCol TO nRow + 7, ;
    nCol + nWinWidth FLOAT DOUBLE
ELSE
  * Adjust for font scaling factors; add half a
  * line so we can size the push buttons big enough
  * to see the hot key underscores; don't FLOAT or
  * we get an unwanted title bar
  DEFINE WINDOW alert COLOR SCHEME 5 ;
                FROM nRow,nCol TO ;
                nRow + (7 * nHgtFact), ;
                nCol + (nWinWidth * nWidFact) +.5 ;
                FONT cWFont,nWSize STYLE cWStyle
ENDIF
ACTIVATE WINDOW alert TOP

SET DEVICE TO SCREEN     && in case printer active

* Draw "icon"

IF _DOS
  @ 0,1 TO 4,11
  DO CASE
    CASE cType = 'CAUTION'
      @ 2,3 SAY 'CAUTION'
    CASE cType = 'STOP'
      @ 2,3 SAY 'S T O P'
    CASE cType = 'INFO'
      @ 2,3 SAY 'I n f o'
    CASE cType = '?'
      @ 2,6 SAY '?'
  ENDCASE
ELSE
  * Windows
  DO CASE
    CASE cType = 'CAUTION'
      @ 2,2.7 SAY 'EXCLAIM.BMP' BITMAP
    CASE cType = 'STOP'
      @ 2,2.7 SAY 'STOP.BMP' BITMAP
    CASE cType = 'INFO'
      @ 2,2.7 SAY 'INFO.BMP' BITMAP
    CASE cType = '?'
      @ 2,2.7 SAY 'QUESTION.BMP' BITMAP
  ENDCASE
ENDIF
* Calc starting column for message lines

nOffset = ;
  IIF(nButWidth <= nTextLen,2,;
      ROUND((nButWidth - nTextLen) / 2,0) + 2)

* Calc starting row to print 1st msg line

DO CASE
  CASE nParms = 5
    n = 2
  CASE nParms < 7
    n = 1
  OTHERWISE
    n = 0
ENDCASE

IF _WINDOWS
  n = n + .4
ENDIF

* Output the message

@ n,nIconLen + nOffset SAY cMsg1
n = n + 1

IF nParms > 5
  @ n,nIconLen + nOffset SAY cMsg2
  n = n + 1
ENDIF

IF nParms > 6
  @ n,nIconLen + nOffset SAY cMsg3
  n = n + 1
ENDIF

IF nParms = 8
  @ n,nIconLen + nOffset SAY cMsg4
ENDIF

* Figure out what the hot keys are

cHotKeys = ''

IF EMPTY(cWait)
  
  * No buttons; return to caller.
  
  DO ACLEANUP
  
  RETURN 'X'
ELSE
  
  IF bUserButs AND '<' $ cWait
    n = AT('<',cWait)
    cHotKeys = UPPER(SUBSTR(cWait,n + 1,1))
    nTime = 2
    
    DO WHILE .t.
      n = AT('<',cWait,nTime)
      IF n = 0 OR n = LEN(cWait)
        EXIT
      ENDIF
      nTime = nTime + 1
      cHotKeys = cHotKeys ;
        + UPPER(SUBSTR(cWait,n + 1,1))
    ENDDO
    
  ELSE
    cHotKeys = 'YNC'
    cWait = ''
    
    FOR n = 1 TO nButtons
      cWait = cWait + cButton[n] + ';'
    ENDFOR
    
    cWait = LEFT(cWait,LEN(cWait) - 1)
  ENDIF
  
  * Calc starting column for buttons
  
  nOffset = FLOOR((FLOOR(((nWinWidth * nWidFact) ;
          - nIconLen) / 2) ;
          - FLOOR(nButWidth / 2)) + nIconLen)

  IF _WINDOWS
    * Seem to need a slight fudge factor
    nOffset = nOffset - 1.5
  ENDIF  

  nWhat = nButDef
  
  DO WHILE .t.
    
    * Create the buttons
    
    IF _WINDOWS
      @ 4.9,nOffset GET nWhat ;
        FUNCTION '*H ' + cWait;
        SIZE 1.5,nOneBut FONT cBFont,nBSize ;
        STYLE cBStyle
    ELSE
      @ 5,nOffset GET nWhat FUNCTION '*H ' + cWait
    ENDIF
    CLEAR TYPEAHEAD
    
    * Dummy up LASTKEY() by stuffing keyboard
    * buffer with a space, then eating it.  This
    * prevents LASTKEY() test below from being
    * "fooled" in some circumstances (mouse used
    * to select ALERT button, and last keystroke
    * before the READ happened to be [Esc]).
    
    * In Windows, for some reason, INKEY()
    * doesn't always eat the space -- it gets
    * passed through to the READ and presses the
    * default button. So we use CHRSAW() to make
    * sure this doesn't happen.
    KEYBOARD ' '
    DO WHILE CHRSAW()
      = INKEY()
    ENDDO
    
    READ CYCLE MODAL OBJECT nButDef
    
    IF LASTKEY() = 27 AND NOT '\?' $ cWait
      
      * If no escape button defined, don't allow
      * exit on [Esc].
      
      LOOP
    ENDIF
    
    IF nButtons = 1
      cReturn = 'X'
    ELSE
      cReturn = SUBSTR(cHotKeys,nWhat,1)
    ENDIF
    
    EXIT
  ENDDO
  
  RELEASE WINDOW alert
  
ENDIF

* Restore user window and get out

IF EMPTY(cWinSave)
  ACTIVATE SCREEN
ELSE
  IF bOWVis
    ACTIVATE WINDOW (cWinSave) SAME
  ELSE
    ACTIVATE WINDOW (cWinSave) SAME NOSHOW
  ENDIF
ENDIF

DO ACLEANUP

RETURN cReturn

*********************************************************************
PROCEDURE ACLEANUP
*
* Common cleanup code called from ALERT() exit
* points.
*

IF TYPE('cBlink') = 'C' AND cBlink <> SET('BLINK')
  
  * Restore BLINK setting if we changed it for
  * window definition
  
  SET BLINK &cBlink
ENDIF

IF cDevice <> 'SCREEN'
  SET DEVICE TO &cDevice
ENDIF

IF nScheme = 21
  
  * Restore user colors if we messed with 'em
  
  SET COLOR OF SCHEME 21 TO &cScheme21
ENDIF

RETURN

*********************************************************************
FUNCTION ABSROW

* Returns the current cursor row in terms of the
* absolute screen coordinate

RETURN IIF(EMPTY(WOUTPUT()),ROW(),;
  WLROW() + ROW() + IIF(WBORDER(),1,0))

* EOF - AbsRow()
*********************************************************************
FUNCTION ABSCOL

* Returns the current cursor column in terms of the
* absolute screen coordinate

RETURN IIF(EMPTY(WOUTPUT()),COL(),;
  WLCOL() + COL() + IIF(WBORDER(),1,0))

* EOF - AbsCol()
*********************************************************************
*********************************************************************
*********************************************************************
* EOF - zzAlert.prg
