*       *********************************************************
*       *                                                         
*       * 03/11/1995            ZZLBLS.PRG               14:51:00 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZLBLS/Windows Setup Code - SECTION 1          
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Label Form update task support code
*--

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZLBLS'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZLBLS/Windows Setup Code - SECTION 2          
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cName      t_aGETvars[1]
#DEFINE t_cDesc      t_aGETvars[2]
#DEFINE t_cDbf       t_aGETvars[3]
#DEFINE t_cNdx1      t_aGETvars[4]
#DEFINE t_cNdxKey1   t_aGETvars[5]
#DEFINE t_cNdxKey2   t_aGETvars[6]
#DEFINE t_cNdxKey3   t_aGETvars[7]
#DEFINE t_cFiltDsc   t_aGETvars[8]
#DEFINE t_cFilt      t_aGETvars[9]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[31]
#DEFINE t_nTopBump   t_aGETvars[32]
#DEFINE t_nBotBump   t_aGETvars[33]

  * And now define the array itself
  DIMENSION t_aGETvars[40]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder= 'zzlbls'     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZLBLS', ;
                         'Label Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  * get filter array list
  IF NOT USED('zzFilt')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzFilt','DBF','Where is the Filter file?'));
        IN 0 AGAIN ALIAS zzFilt
  ENDIF
  SELECT zzFilt
  SET INDEX TO zzFilt
  SET ORDER TO 1

  IF NOT USED('zzlbls')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzlbls','DBF','Where is the labels file?'));
        IN 0 AGAIN ALIAS zzlbls
  ENDIF
  SELECT zzlbls
  SET INDEX TO (m.t_cOrder)
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 31,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cDesc, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'lbls_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE lbls_act() ;
         DEACTIVATE lbls_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzlbls')    && Remember data table order
  m.t_nRecno = RECNO('zzlbls')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzFilt
    USE
    SELECT zzlbls
    USE

    * Close associated browse window also, if open.
    IF WEXIST('Label_List')
      DEACTIVATE WINDOW 'Label_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *              ZZLBLS/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 5.462,4.167 SAY "Label File Name:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 13.308,2.667 SAY "Order the labels by up to 3 fields." + CHR(13) + ;
		"(Ex: by State then City then Zip)" + CHR(13) + ;
		"Leave blank if no order necessary." ;
	SIZE 3.000,33.667, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 20.000,2.833 SAY "Index file name, (up to 8 characters.)" + CHR(13) + ;
		"Leave blank if not ordering the labels." ;
	SIZE 2.000,36.833, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 9.462,2.500 SAY '(Data file name, up to 8 characters.)' + CHR(13) + ;
		'(Usually "zzmast")' ;
	SIZE 2.000,34.500, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 4.077,2.167 TO 4.077,78.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.692,2.167 TO 0.692,78.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,1.833 TO 4.154,1.833 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,78.500 TO 4.077,78.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 23.692,3.667 SAY "Print Labels Filter/Query List      (List Defined in Filter Window) " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 23.308,1.833 TO 23.308,82.166 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 23.308,1.833 TO 25.154,1.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 23.308,82.000 TO 25.000,82.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 25.000,2.000 TO 25.000,82.333 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 25.769,2.333 TO 25.769,82.166 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 25.769,2.000 TO 28.384,2.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 28.385,2.333 TO 28.385,82.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 25.846,82.000 TO 28.384,82.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cName) + 7)
@ 5.615,25.333 GET t_cName ;
	SIZE 1.000,11.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 9.923,44.333 GET t_cDbf ;
	SIZE 1.000,12.500 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 6.846,25.333 GET t_cdesc ;
	SIZE 1.000,35.500 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 13.462,44.000 GET t_cNdxKey1 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.000,44.000 GET t_cNdxKey2 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 16.538,44.000 GET t_cNdxKey3 ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,17.833 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 20.385,44.167 GET t_cNdx1 ;
	SIZE 1.000,12.667 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 26.308,3.167 GET t_cFiltDsc ;
	PICTURE "@^" ;
	FROM _zzFilt ;
	SIZE 1.538,77.333 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 28.769,2.500 SAY IIF(_Ok2All,'','For: Owner = [' +_Owner + ']' ) ;
	SIZE 1.000,33.333 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 1.000,3.000 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("modify.bmp","BMP|ICO|PCT|ICN","Where is modify?")) + ";" + ;
		(LOCFILE("execute.bmp","BMP|ICO|PCT|ICN","Where is execute?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,7.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cName) )
@ 6.846,8.667 SAY "Description:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 4.923,1.833 TO 4.923,21.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.923,1.833 TO 8.231,1.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.000,21.333 TO 8.154,21.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.154,2.000 TO 8.154,21.667 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.923,1.833 TO 8.923,40.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 8.923,1.833 TO 12.000,1.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.846,1.833 TO 12.846,40.333 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.846,1.833 TO 17.000,1.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.538,1.667 TO 19.538,40.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.538,1.667 TO 22.461,1.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.000,40.167 TO 11.846,40.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.846,2.000 TO 11.846,40.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.923,40.167 TO 16.846,40.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 16.846,2.000 TO 16.846,40.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.615,40.000 TO 22.461,40.000 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 22.462,1.833 TO 22.462,40.333 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.923,23.667 TO 4.923,62.167 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.923,23.333 TO 8.385,23.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.308,23.667 TO 8.308,62.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.923,62.167 TO 8.308,62.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 8.923,42.667 TO 8.923,58.834 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 8.923,42.333 TO 12.000,42.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.846,42.667 TO 11.846,58.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.000,58.667 TO 11.846,58.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.846,42.833 TO 12.846,63.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.846,42.500 TO 18.769,42.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 18.692,42.833 TO 18.692,63.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.000,63.333 TO 18.692,63.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.462,42.833 TO 19.462,59.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.462,42.500 TO 22.539,42.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 22.385,42.833 TO 22.385,59.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.538,58.833 TO 22.384,58.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *               ZZLBLS/Windows Cleanup Code               
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZLBLS/Windows Supporting Procedures and Functions    
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION lbls_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzlbls.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION lbls_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD labels OF _MSYSMENU
    RELEASE POPUP labels
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzlbls', RECNO('zzlbls') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzlbls

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzlbls', RECNO('zzlbls')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzlbls
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cName )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,8 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,8 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

  * place chosen filter into report filter memvar
  SELECT zzFilt
  IF NOT EMPTY(t_cFiltDsc)

    SEEK UPPER(t_cFiltDsc)

    * Limit user to "owned" records if required

    * Add something like [owner='JFK' AND ]
    * to the begining of the filter string
    * if limiting user access to not all records

    IF _Ok2All
      t_cFilt = zzFilt->FiltStr
    ELSE
      t_cFilt = 'owner=[' +_Owner + '] AND ' + ALLTRIM(zzFilt->FiltStr)
      * disable "Owner = " display on labels, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') ' + ALLTRIM(qFiltList)
    ENDIF

  ELSE
    IF _Ok2All
      t_cFilt = ''
    ELSE
      t_cFilt = 'owner=[' +_Owner + ']'
      * disable "Owner = " display on reports, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') '
    ENDIF
  ENDIF

  * if choice is picture button, strip off ".BMP" from end
  * make sure .bmp button file names match menu options!
  m.cOption = STRTRAN(m.cOption,'.BMP','')
  * identify file name, strip off path + back-slashes
  m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

  SELECT zzlbls
  m.cOption = UPPER( ALLTRIM(m.cOption) )

  IF  m.cOption = 'COPY'
    APPEND BLANK
    GATHER FROM t_aGETvars MEMO
    DO load_form
    DO show_form
    DO wUnlock WITH m.cTaskAlias
    WAIT 'Record Copied' Window NOWAIT
    RETURN .T.
  ENDIF

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)


    CASE m.cOption = 'MODIFY'
      DO LblMod
    CASE m.cOption = 'EXECUTE'
      DO LblExe
    CASE m.cOption = 'LIST'
      * Launch an independant BROWSE window, linked to ours.
      DO wLaunch WITH 'lbllist IN zzlbls'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE lbllist
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* filter update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzlbls

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzlbls.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'Label_List' ;
         FIELDS Desc,Name ;
         WHEN EVALUATE( 'zzlbls' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZLBLS")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzlbls
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save changes made to this label ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      DO CASE
        CASE EMPTY(t_cName)
          m.cReason = 'A label Name is required'
          m.nBadField = OBJNUM(t_cName)
        CASE EMPTY(t_cDbf)
          m.cReason = 'A Label Database is required'
          m.nBadField = OBJNUM(t_cDbf)
        CASE EMPTY(t_cDesc)
          m.cReason = 'A Label Description is required'
          m.nBadField = OBJNUM(t_cDesc)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
FUNCTION LblMod
* Modify selected label
*

mLbl = ALLTRIM(t_cName)
mDbf = ALLTRIM(t_cDbf)
mNdx = ALLTRIM(t_cNdx1)
mLblFilt = t_cFilt

IF NOT USED(mDbf)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(mDbf,'DBF','Where is ' + mDbf + '.dbf?'));
      IN 0 AGAIN ALIAS &mdbf
ENDIF
SELECT &mDbf
mLblKey  = BldIdx(mNdx)

* Place other cases here for dbf's with many indexes
* that you may want open for rushmore optimization!
* one each, depending on whether user entered an
* index file name.

* Add label order index to master index list, if necessary
LblNdxs = mNdx + ',' + _MastNdx

DO CASE
CASE .NOT. EMPTY(mNdx) .AND. mDbf = _mastfile
  SET INDEX TO &LblNdxs
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf = _mastfile
  SET INDEX TO &_MastNdx
  SET ORDER TO 1
* put 2 cases here, above last 2
CASE .NOT. EMPTY(mNdx) .AND. mDbf <> _mastfile
  SET INDEX TO &mNdx
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf <> _mastfile
  SET INDEX TO
ENDCASE

MODI LABEL &mLbl

SELECT &_MastFile
SET INDEX TO
SET INDEX TO &_MastNdx

RETURN

* EOF - LblMod
********************************************************************
FUNCTION LblExe
* Execute selected label
*

mLbl = ALLTRIM(t_cName)
mDbf = ALLTRIM(t_cDbf)
mNdx = ALLTRIM(t_cNdx1)

IF NOT USED(mDbf)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(mDbf,'DBF','Where is ' + mDbf + '.dbf?'));
      IN 0 AGAIN ALIAS &mdbf
ENDIF
SELECT &mDbf
mLblFilt = t_cFilt
mLblKey  = BldIdx(mNdx)

* Place other cases here for dbf's with many indexes
* that you may want open for rushmore optimization!
* one each, depending on whether user entered an
* index file name.
* Add label order index to master index list, if necessary
LblNdxs = mNdx + ',' + _MastNdx

DO CASE
CASE .NOT. EMPTY(mNdx) .AND. mDbf = _mastfile
  SET INDEX TO &LblNdxs
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf = _mastfile
  SET INDEX TO &_MastNdx
  SET ORDER TO 1
* put 2 cases here, above last 2
CASE .NOT. EMPTY(mNdx) .AND. mDbf <> _mastfile
  SET INDEX TO &mNdx
  SET ORDER TO 1
CASE EMPTY(mNdx) .AND. mDbf <> _mastfile
  SET INDEX TO
ENDCASE

IF .NOT. EMPTY(mLblFilt) OR NOT _Ok2All
  IF zzCntnue('Do you want to PREVIEW the labels?')
    LABEL FORM &mLbl TO PRINT PREVIEW FOR &mLblFilt
  ELSE
    * continue
  ENDIF

  IF zzCntnue('Do you want to PRINT the labels?')
    LABEL FORM &mLbl TO PRINT PROMPT NOCONSOLE FOR &mLblFilt
  ELSE
    * continue
  ENDIF

ELSE

  IF zzCntnue('Do you want to PREVIEW the labels?')
    LABEL FORM &mLbl TO PRINT PREVIEW
  ELSE
    * continue
  ENDIF

  IF zzCntnue('Do you want to PRINT the labels?')
    LABEL FORM &mLbl TO PRINT PROMPT NOCONSOLE
  ELSE
    * continue
  ENDIF

ENDIF

WAIT 'Label print finished ' WINDOW TIMEOUT 2

SET INDEX TO &_MastNdx

RETURN

* EOF - LblExe
*******************************************************************
FUNCTION BLdIdx
PARAMETERS TempNdx
* Build index string for label, index selected database if desired
* TempNdx is the index file name
*

IF EMPTY(t_cNdxKey1)
  RETURN ''
ENDIF

NdxStr  = ''
NdxStr1 = ''
NdxStr2 = ''
NdxStr3 = ''

* Get index key for field 1
IF .NOT. EMPTY(t_cNdxKey1)
  mPos = ASCAN(_zzsmast,t_cNdxKey1)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)

  NdxFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
  UsrType = _zzsmast(mSub,3)          && Field type
  UsrLen  = _zzsmast(mSub,4)          && Field Length
  UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric

  DO CASE
  CASE UsrType = 'D'
    NdxStr1 = [DTOS(] + ALLTRIM(NdxFld) + [)]
  CASE UsrType = 'N'
    NdxStr1 = [STR(] + ALLTRIM(NdxFld) + [)]
  OTHERWISE
    NdxStr1 = [UPPER(] + ALLTRIM(NdxFld) + [)]
  ENDCASE

  NdxStr = NdxStr1
ENDIF

* Get index key for field 2
IF .NOT. EMPTY(t_cNdxKey2)
  mPos = ASCAN(_zzsmast,t_cNdxKey2)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)

  NdxFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
  UsrType = _zzsmast(mSub,3)          && Field type
  UsrLen  = _zzsmast(mSub,4)          && Field Length
  UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric

  DO CASE
  CASE UsrType = 'D'
    NdxStr2 = [DTOS(] + ALLTRIM(NdxFld) + [)]
  CASE UsrType = 'N'
    NdxStr2 = [STR(] + ALLTRIM(NdxFld) + [)]
  OTHERWISE
    NdxStr2 = [UPPER(] + ALLTRIM(NdxFld) + [)]
  ENDCASE

  NdxStr = NdxStr + '+' + NdxStr2
ENDIF

* Get index key for field 3
IF .NOT. EMPTY(t_cNdxKey3)
  mPos = ASCAN(_zzsmast,t_cNdxKey3)
  mSub = ASUBSCRIPT(_zzsmast,mPos,1)

  NdxFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
  UsrType = _zzsmast(mSub,3)          && Field type
  UsrLen  = _zzsmast(mSub,4)          && Field Length
  UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric

  DO CASE
  CASE UsrType = 'D'
    NdxStr3 = [DTOS(] + ALLTRIM(NdxFld) + [)]
  CASE UsrType = 'N'
    NdxStr3 = [STR(] + ALLTRIM(NdxFld) + [)]
  OTHERWISE
    NdxStr3 = [UPPER(] + ALLTRIM(NdxFld) + [)]
  ENDCASE

  NdxStr = NdxStr + '+' + NdxStr3
ENDIF

IF .NOT. EMPTY(NdxStr)

  IF zzCntnue('Do you want to CREATE new report index?') ;
      OR NOT FILE(ALLTRIM(t_cNdx1)+'.IDX')

    WAIT 'Indexing ' + ALLTRIM(NdxStr) ;
    + ' for ' + ALLTRIM(STR(RECC())) + ' records now...' WINDOW NOWAIT

    DEFINE WINDOW ndx ;
      AT 4,7 ;
      SIZE 6,70 ;
      TITLE  'Report Index' ;
      FONT 'Times New Roman', 10 ;
      STYLE 'B' ;
      FLOAT ;
      CLOSE ;
      NOMINIMIZE ;
      DOUBLE
    MOVE WINDOW ndx CENTER
    ACTIVATE WINDOW ndx

    TempKey = ALLTRIM(NdxStr)
    SET TALK ON
    INDEX ON &TempKey TO &TempNdx COMPACT
    SET TALK OFF
    DEACTIVATE WINDOW ndx

  ELSE
    * continue, no index
  ENDIF { user wants to create index }

ELSE

  WAIT 'Labels will be in search order, Press <Enter> now.' WINDOW

ENDIF

RETURN NdxStr

* EOF - BldNdx
********************************************************************
********************************************************************
********************************************************************
* EOF - zzLbls.prg