* ZZPick.prg
* Picklist of choices based on current edit field
* User may choose one or many from list, or modify list
* p_otherfld is passed if picking for field NOT in zzmast.dbf!
*
PARAMETERS cwindow, cmsgtext, p_otherfld
*
*

*DO CASE  
*CASE TYPE(VARREAD()) <> 'C' .AND. LASTKEY() = 23
*   RETURN (.F.)                         && don't allow F2 to activate picklist on type "N"
*CASE TYPE(VARREAD()) <> 'C'
*   RETURN (.T.)
*CASE LASTKEY() <> 23                    && F2 is set to keyboard chr(23) at startup
*   RETURN (.T.)
*ENDCASE

* Identify calling program to determine
* method of defining picklist selections
* If filter program, popup must be taken from
* the appropriate field containing the
* selected zzMast.dbf field label.

DO CASE

CASE _aWindows[1] = '1_ZZFILT'
  mEditVar = varread()                && get current "GET" field
  mDbfField = FiltVar()

CASE _aWindows[1] = '1_ZZQ'
  mEditVar = varread()                && get current "GET" field
  *** get header for window from dbf field name
  mArrayNo = SUBSTR(mEditVar,9,2)     && get array cell for the field
  mArrayNo = STRTRAN(mArrayNo,']','') && strip off "]" to keep number
  mArrayNo = VAL(mArrayNo)            && convert to numeric
  mDbfField = FIELD(mArrayNo)         && get dbf field name currently edited

OTHERWISE
  mEditVar = varread()                && get current "GET" field
  *** get header for window from dbf field name
  mArrayNo = SUBSTR(mEditVar,12,2)    && get array cell for the field
  mArrayNo = STRTRAN(mArrayNo,']','') && strip off "]" to keep number
  mArrayNo = VAL(mArrayNo)            && convert to numeric
  mDbfField = FIELD(mArrayNo)         && get dbf field name currently edited

ENDCASE

ON KEY LABEL F2


sv_pdbf  = ALIAS(SELECT())             && save current dbf name
sv_wndw  = WOUTPUT()                   && save current window name
sv_multi = ''                          && save all multiple picks 

IF NOT USED('zzpick')
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE('zzpick','DBF','Where is the Picklist file?'));
      IN 0 EXCLUSIVE AGAIN ALIAS zzpick
ENDIF
SELECT zzpick

SET FILTER TO pickfld = mdbffield
GO TOP

#REGION 1
PRIVATE cTitle, cReply

* If the title is a window name, convert it to the window's title.
*m.cTitle = IIF( WEXIST(m.cWindow), WTITLE(m.cWindow), m.cWindow )
*m.cTitle = ' ' + ALLTRIM(m.cTitle) + ' '
m.ctitle = 'List For: ' + PROPER(ALLTRIM(mdbffield))

m.cReply = ''		&& Have push buttons return string values

* We need to be sure any saved task GETS do not interfere
* with the message box operation.
DO wModalRead WITH 'read1()'

ON KEY LABEL F2 KEYBOARD CHR(23)

* Return prompt of button selected
*RETURN ALLTRIM(UPPER(m.cReply))
RETURN ''

* EOF - Procedure zzQuest
***********************************************************
FUNCTION read1
*
* Is called under control of the zzproc function wModalRead. It
* issues the GETs and executes the READ.
*

*********
#REGION 0
REGIONAL m.currarea, m.talkstat, m.compstat

IF SET("TALK") = "ON"
	SET TALK OFF
	m.talkstat = "ON"
ELSE
	m.talkstat = "OFF"
ENDIF
m.compstat = SET("COMPATIBLE")
SET COMPATIBLE FOXPLUS


IF NOT WEXIST("pick")
	DEFINE WINDOW pick ;
		AT  0.000, 0.000  ;
		SIZE 17.538,71.167 ;
		TITLE m.cTitle ;
		FONT "MS Sans Serif", 8 ;
		STYLE "B" ;
		FLOAT ;
		NOCLOSE ;
		NOMINIMIZE ;
		DOUBLE
	MOVE WINDOW pick CENTER
ENDIF

*********
#REGION 1
IF WVISIBLE("pick")
	ACTIVATE WINDOW pick SAME
ELSE
	ACTIVATE WINDOW pick NOSHOW
ENDIF

IF NOT WVISIBLE("pick")
	ACTIVATE WINDOW pick
ENDIF

*** Main procedure for picklist

*---------------
getpick = .T.
DO WHILE getpick

   p_choice = 5
   @  1,52 GET p_choice ;
      PICTURE '@*V  Replace/Pick ; Append ; Edit List ; \?Cancel ' ;
      SIZE 2,16,1 ;
      FONT 'MS Sans Serif',8

  DEFINE POPUP plist FROM 0,0 TO 21,30;
    IN WINDOW pick ;
    MULTISELECT ;
    MOVER ;
    MARGIN ;
    SCROLL ;
 
  popnum = 1

  GO TOP

  IF .NOT. EOF()
    getpop = .T.
    DO WHILE getpop .AND. .NOT. EOF()
      DEFINE BAR popnum OF plist PROMPT desc
      SKIP
      IF EOF()
        EXIT
      ENDIF
      popnum = popnum + 1
    ENDDO
  ELSE
      DEFINE BAR 1 OF plist PROMPT 'No ' + ALLTRIM(mdbffield) + ' entered'
  ENDIF

  ACTIVATE POPUP plist NOWAIT

  READ CYCLE MODAL

  DO CASE

  CASE p_choice = 3                      && Edit picklist 
     IF EOF()
       APPEND BLANK
       REPLACE pickfld with mdbffield
     ENDIF
     DO pickmnt 
     DEACTIVATE POPUP plist
     LOOP

  CASE (p_choice = 1 .OR. LASTKEY() = 23)    && OVERWRITE field
     multipick = ''
     FOR i = 1 TO CNTBAR('plist')
        IF mrkbar('plist',i) = .T.
           IF EMPTY(multipick)
              multipick = ALLTRIM(PRMBAR('plist',i))
           ELSE
              multipick = multipick + ',' + ALLTRIM(PRMBAR('plist',i))
           ENDIF
        ENDIF
     ENDFOR

     &meditvar. = multipick              
     SELECT (sv_pdbf)
     DEACTIVATE WINDOW pick
     DEACTIVATE POPUP plist
     KEYBOARD CHR(13)
     EXIT

  CASE (p_choice = 2 )    && APPEND field value to end of field
     multipick = ''
     FOR i = 1 TO CNTBAR('plist')
        IF mrkbar('plist',i) = .T.
           IF EMPTY(multipick)
              multipick = ALLTRIM(PRMBAR('plist',i))
           ELSE
              multipick = multipick + ',' + ALLTRIM(PRMBAR('plist',i))
           ENDIF
        ENDIF
     ENDFOR
      IF LEN(TRIM(&meditvar.)) > 0           && if data is already in field,
        &meditvar. = ALLTRIM(&meditvar.) + ',' + multipick + SPACE(80)
     ELSE
        &meditvar. = SUBSTR(multipick,1,LEN(&meditvar)) + SPACE(80)
     ENDIF
     SELECT (sv_pdbf)
     DEACTIVATE WINDOW pick
     DEACTIVATE POPUP plist
     KEYBOARD CHR(13)
     EXIT

  CASE p_choice = 5 .OR. LASTKEY() = 27
     SELECT (sv_pdbf)
     DEACTIVATE WINDOW pick
     DEACTIVATE POPUP plist
     EXIT
   
  ENDCASE

ENDDO { while getpick }
*****

RELEASE WINDOW pick

#REGION 0
IF m.talkstat = "ON"
	SET TALK ON
ENDIF
IF m.compstat = "ON"
	SET COMPATIBLE ON
ENDIF

RETURN

* EOF - FUNCTION read1
***********************************************************************
*!*********************************************************************
*!
*!      Procedure: PICKMNT
*!
*!      Called by: PICKLIST           (procedure in ZZPROC.PRG)
*!
*!          Calls: ON_KEY             (procedure in ZZPROC.PRG)
*!
*!*********************************************************************
PROCEDURE pickmnt
*PARAMETERS editmode,edtitle
* picklist maintenance
*

DEFINE WINDOW zpickmnt FROM 10,17 TO 25,70 ;
   TITLE ' F3 = Save F4 = Add F5 = Del ' ;
   FONT  'Times New Roman,10' ;
   STYLE 'N' ;
   FLOAT ;
   CLOSE ;
   NOMINIMIZE ;
   DOUBLE
ACTIVATE WINDOW zpickmnt

*IF editmode = 'add'
*   SCATTER MEMVAR BLANK
*   m->pickfld = browkey                 && defined in function picklist above
*ELSE
*   SCATTER MEMVAR
*ENDIF

PUSH KEY                                && save "ON KEY" commands
*DO on_key                               && clear key definitions


*------ handle add, modify (chg), or delete modes
ON KEY LABEL F3 KEYBOARD CHR(23)  && ctrl-w, save
ON KEY LABEL F4 DO pickadd  && ctrl-N, add (new record)
ON KEY LABEL F5 KEYBOARD CHR(20)  && ctrl-T, delete (tag)

BROW FIEL DESC

DEACTIVATE WINDOW zpickmnt

ON KEY LABEL F3
ON KEY LABEL F4
ON KEY LABEL F5

POP KEY                                 && restore "ON KEY" commands

RETURN

* - eof - PROCEDURE pickmnt

***********************************************************************
PROCEDURE pickadd
* add record to picklist, put edit field into ->pickfld
*

APPEND BLANK
REPLACE pickfld with mdbffield

RETURN

* - eof - PROCEDURE pickadd

***********************************
FUNCTION FiltVar
* Get the zzmast.dbf field name for the 
* current filter value being edited in the filter window.
*

PRIVATE FiltFld

GetFld = UPPER(ALLTRIM(varread()))
RtrnVal = ''

DO CASE
CASE GetFld = 'T_AGETVARS(5)'
  FldLbl = ALLTRIM(T_AGETVARS(3))
CASE GetFld = 'T_AGETVARS(11)'
  FldLbl = ALLTRIM(T_AGETVARS(9))
CASE GetFld = 'T_AGETVARS(17)'
  FldLbl = ALLTRIM(T_AGETVARS(15))
CASE GetFld = 'T_AGETVARS(23)'
  FldLbl = ALLTRIM(T_AGETVARS(21))
CASE GetFld = 'T_AGETVARS(29)'
  FldLbl = ALLTRIM(T_AGETVARS(27))
CASE GetFld = 'T_AGETVARS(35)'
  FldLbl = ALLTRIM(T_AGETVARS(33))
CASE GetFld = 'T_AGETVARS(41)'
  FldLbl = ALLTRIM(T_AGETVARS(39))
CASE GetFld = 'T_AGETVARS(47)'
  FldLbl = ALLTRIM(T_AGETVARS(45))
OTHERWISE
*  RETURN ''
ENDCASE

*UsrLft   = ALLTRIM(UsrLft)
*UsrFld   = ALLTRIM(UsrFld)
*UsrOp    = ALLTRIM(SUBSTR(UsrOp,1,2))
*UsrVal   = ALLTRIM(UsrVal)
*UsrAndOr = ALLTRIM(UsrAndOr)
*UsrRt    = ALLTRIM(UsrRt)

*clear wind
*susp
*wait 'usrfld-'+usrfld+'-  usrop-'+usrop+'-  usrval-'+usrval+'-  usrandor-'+usrandor window
*return ''
*PRIVATE BldString,mPos,mSub,UsrFld,UsrType,UsrLen
*PRIVATE UsrDec,UsrOp,UsrVal,UsrAndOr, FiltFld

* Find array position, subscript ;
* of user selected "English, not dbf" field name

mPos = ASCAN(_zzsmast,FldLbl)
mSub = ASUBSCRIPT(_zzsmast,mPos,1)

RtrnVal = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
*UsrType = zzsmast(mSub,3)          && Field type
*UsrLen  = zzsmast(mSub,4)          && Field Length
*UsrDec  = zzsmast(mSub,5)          && Decimals, if numeric

RETURN  ( RtrnVal )

* EOF - FiltVar
****************************************************
****************************************************
* EOF - zzPick.prg
****************************************************
****************************************************