*       *********************************************************
*       *                                                         
*       * 03/11/1995            ZZPREF.PRG               16:26:14 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZPREF/Windows Setup Code - SECTION 1          
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Filter update task support code
*--

* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZPREF'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZPREF/Windows Setup Code - SECTION 2          
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cTitle     t_aGETvars[1]
#DEFINE t_cSernum    t_aGETvars[2]
#DEFINE t_cwall      t_aGETvars[3]
#DEFINE t_cwp        t_aGETvars[4]
#DEFINE t_cp         t_aGETvars[5]
#DEFINE t_cHlpFile   t_aGETvars[6]
#DEFINE t_cTopicNo   t_aGETvars[7]
#DEFINE t_cWkDir     t_aGETvars[8]
#DEFINE t_cMastFile  t_aGETvars[9]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[21]
#DEFINE t_nTopBump   t_aGETvars[22]
#DEFINE t_nBotBump   t_aGETvars[23]

  * And now define the array itself
  DIMENSION t_aGETvars[40]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder= ''     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZdata', ;
                         'User Preferences Update' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  IF NOT USED('zzdata')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzdata','DBF','Where is the Preferences file?'));
        IN 0 AGAIN ALIAS zzdata
  ENDIF
  SELECT zzdata

  DIMENSION Wall(1)
  =ADIR(Wall,'*.BMP')

  DIMENSION MastFile(1)
  =ADIR(MastFile,'*.DBF')

  DIMENSION HlpFiles(1)
  =ADIR(HlpFiles,'*.HLP')

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 26,96 ;

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cTitle, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'pref_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE pref_act() ;
         DEACTIVATE pref_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzdata')    && Remember data table order
  m.t_nRecno = RECNO('zzdata')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzData
    * set global wallpaper memvar for exit
    *_wall = ALLTRIM(zzData->Wall)
    USE
    _ReStart = .T.  && Re-Start SalesBridge zz.prg

    DO wDelTask WITH m.cTaskAlias

  ENDIF

  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *              ZZPREF/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 8.308,34.167 SAY "Window Title:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 10.846,33.333 SAY "Serial Number:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 13.154,27.000 TO 13.154,27.000 ;
	PEN 1, 8 ;
	STYLE "16"
@ 13.385,26.000 SAY "Wallpaper File: (.BMP)" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 18.308,31.500 SAY "Word Processor:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 15.923,31.500 SAY "Help File: (.HLP)" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.333,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cTitle) + 4)
@ 5.692,51.333 GET t_cP ;
	PICTURE "@*C     " ;
	SIZE 1.308,7.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 8.308,51.667 GET t_cTitle ;
	SIZE 1.000,36.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 10.923,51.667 GET t_cSerNum ;
	SIZE 1.000,18.333 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K !!!!!!!!!!!!" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 18.077,51.500 GET t_cWp ;
	PICTURE "@^ None;MicroSoft Word;Word Perfect" ;
	SIZE 1.538,17.167 ;
	DEFAULT "None" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 13.154,51.500 GET t_cWall ;
	PICTURE "@^" ;
	FROM Wall ;
	SIZE 1.538,17.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 15.692,51.500 GET t_cHlpFile ;
	PICTURE "@^" ;
	FROM HlpFiles ;
	SIZE 1.538,17.167 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,1.000,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cTitle) )
@ 0.923,4.167 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,8.667,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 6.846,3.500 TO 6.846,3.500 ;
	PEN 1, 8 ;
	STYLE "16"
@ 4.000,3.500 TO 4.000,32.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.615,3.167 TO 4.077,3.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,32.500 TO 4.077,32.500 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.308,3.167 TO 5.308,47.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.385,3.167 TO 7.231,3.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.385,47.500 TO 7.154,47.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 7.077,3.500 TO 7.077,47.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.308,50.833 TO 5.308,54.333 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 5.308,50.500 TO 7.308,50.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 7.231,50.833 TO 7.231,54.333 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.308,54.167 TO 7.308,54.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 5.769,10.333 SAY "Password Must Be Entered On Startup:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.538,3.333 TO 0.538,32.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 7.769,50.833 TO 7.769,89.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 7.769,50.500 TO 9.769,50.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.692,50.833 TO 9.692,89.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.769,89.333 TO 9.692,89.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 9.385,3.500 TO 9.385,3.500 ;
	PEN 1, 8 ;
	STYLE "16"
@ 7.846,3.167 TO 7.846,47.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.923,3.167 TO 9.769,3.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.923,47.500 TO 9.692,47.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 9.615,3.500 TO 9.615,47.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 11.923,3.500 TO 11.923,3.500 ;
	PEN 1, 8 ;
	STYLE "16"
@ 10.385,3.167 TO 10.385,47.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 10.462,3.167 TO 12.308,3.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 10.462,47.500 TO 12.231,47.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.154,3.500 TO 12.154,47.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 14.462,3.500 TO 14.462,3.500 ;
	PEN 1, 8 ;
	STYLE "16"
@ 12.923,3.167 TO 12.923,47.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.000,3.167 TO 14.846,3.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.000,47.500 TO 14.769,47.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 14.692,3.500 TO 14.692,47.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 17.000,3.500 TO 17.000,3.500 ;
	PEN 1, 8 ;
	STYLE "16"
@ 15.462,3.167 TO 15.462,47.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 15.538,3.167 TO 17.384,3.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 15.538,47.500 TO 17.307,47.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 17.231,3.500 TO 17.231,47.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.385,3.500 TO 19.385,3.500 ;
	PEN 1, 8 ;
	STYLE "16"
@ 17.846,3.167 TO 17.846,47.667 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 17.923,3.167 TO 19.769,3.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 17.923,47.500 TO 19.692,47.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.615,3.500 TO 19.615,47.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 10.385,50.833 TO 10.385,76.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 10.385,50.500 TO 12.385,50.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.308,50.833 TO 12.308,76.666 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 10.385,76.667 TO 12.308,76.667 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.923,51.000 TO 12.923,77.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.923,50.667 TO 14.923,50.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 14.846,51.000 TO 14.846,76.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 12.923,76.833 TO 14.846,76.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 15.462,51.000 TO 15.462,77.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 15.462,50.667 TO 17.462,50.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 17.385,51.000 TO 17.385,76.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 15.462,76.833 TO 17.385,76.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 17.846,51.000 TO 17.846,77.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 17.846,50.667 TO 19.846,50.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.769,51.000 TO 19.769,76.833 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 17.846,76.833 TO 19.769,76.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *               ZZPREF/Windows Cleanup Code               
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZPREF/Windows Supporting Procedures and Functions    
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION pref_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzpref.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION pref_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD pref OF _MSYSMENU
    RELEASE POPUP pref
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzdata', RECNO('zzdata') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzdata

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzdata', RECNO('zzdata')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzdata
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cTitle )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

SELECT zzdata
m.cOption = UPPER( ALLTRIM(m.cOption) )

  DO CASE
    * First, handle the common task button options.
    CASE controls(cOption, bInObject)

  ENDCASE

  RETURN .T.




********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzdata
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to save preference changes ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      DO CASE
        *CASE EMPTY(t_c???)

      ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
********************************************************************
********************************************************************
* EOF - zzpref.prg