*       *********************************************************
*       *                                                         
*       * 03/13/1995            ZZREPL.PRG               12:57:20 
*       *                                                         
*       *********************************************************
*       *                                                         
*       * Patrick Smith                                           
*       *                                                         
*       * Copyright (c) 1995 Contact Technology                   
*       * 26 Aries Lane                                           
*       * Novato, CA  94947                                       
*       * U.S.A                                             
*       *                                                         
*       * Description:                                            
*       * This program was automatically generated by GENSCRN.    
*       *                                                         
*       *********************************************************

PARAMETERS cevent, ctaskalias

*       *********************************************************
*       *                                                         
*       *          ZZREPL/Windows Setup Code - SECTION 1          
*       *                                                         
*       *********************************************************
*

#REGION 1
*++
* Mass Replace task support code
*--
* Make sure this is the ONLY task window open!
IF NOT EMPTY(_aWindows[1])
  IF _aWindows[1] = '1_ZZREPL'
    * OK to go back to this window
  ELSE
    WAIT 'Close all windows before performing this function, press <Enter>' WINDOW
    RETURN
  ENDIF
ENDIF

PRIVATE ALL EXCEPT _*


*       *********************************************************
*       *                                                         
*       *          ZZREPL/Windows Setup Code - SECTION 2          
*       *                                                         
*       *********************************************************
*

#REGION 1
* Define offsets into GET variable array structure.
* The first section of the array must match the table layout
* so we can use GATHER/SCATTER to transfer between file and array.
* Make sure it is an exact match to the dbf structure!
* Adjust the size of the array below to hold the memvars

#DEFINE t_cDesc      t_aGETvars[1]
#DEFINE t_cField     t_aGETvars[2]
#DEFINE t_cWith      t_aGETvars[3]
#DEFINE t_cAndOr5    t_aGETvars[4]
#DEFINE t_cFiltDsc   t_aGETvars[5]
#DEFINE t_cFilt      t_aGETvars[6]

* Now define elements for additional non-table fields
#DEFINE t_cOption    t_aGETvars[31]
#DEFINE t_nTopBump   t_aGETvars[32]
#DEFINE t_nBotBump   t_aGETvars[33]

  * And now define the array itself
  DIMENSION t_aGETvars[40]

  * Declare Screen-set wide global variables
  m.t_cWindow = ''   && Window name for this instance
  m.t_nWinRow = 2    && Default row for our window
  m.t_nWinCol = 2    && Default column for our window
  m.t_nCurObj = 0    && Current object number
  m.t_nRecno = 0     && Current record number
  m.t_cOrder = 'zzRepl'     && Default table order.
  m.t_bAddNew = .F.  && Set true if adding new record
  m.t_bChanges = .F. && Changes have been made flag.
  m.t_bAtTop = .F.   && Beginning of file flag
  m.t_bAtEnd = .F.   && End of file flag

  * Determine our task alias, or create a new one.
  IF m.cEvent = 'LAUNCH'
    * Look for topmost existing instance of this task first.
    m.t_cWindow = wTaskWin( m.cTaskAlias )

    IF EMPTY( m.t_cWindow )
      * Create a new instance of this task.
      m.cTaskAlias = wNewTask( m.cTaskAlias )
      IF EMPTY( m.cTaskAlias )
        RETURN .F.
      ENDIF

      m.t_cWindow = wAddWin( m.cTaskAlias, 'ZZREPL', ;
                         'Mass Replace Field' )
    ELSE
      * Get the task alias associated with window we found.
      m.cTaskAlias = wWinAlias( m.t_cWindow )
    ENDIF
  ENDIF

  * Restore last saved state (if any) of memory variables.
  DO wGetState WITH m.cTaskAlias

  * Make sure the files we use are open
  * get filter array list
  IF NOT USED('zzFilt')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzFilt','DBF','Where is the Filter file?'));
        IN 0 AGAIN ALIAS zzFilt
  ENDIF
  SELECT zzFilt
  SET INDEX TO zzFilt
  SET ORDER TO 1

  IF NOT USED('zzrepl')
    * Use AGAIN in case another task, or BROWSE, has file open
    * under a different alias name.
    USE (LOCFILE('zzrepl','DBF','Where is the replace file?'));
        IN 0 AGAIN ALIAS zzrepl
  ENDIF
  SELECT zzRepl
  SET INDEX TO (m.t_cOrder)
  SET ORDER TO (m.t_cOrder)

  * Restore current record from saved context.
  IF m.t_nRecno > 0 AND m.t_nRecno <= RECCOUNT()
    GO m.t_nRecno
  ENDIF

  DO CASE
    CASE m.cEvent = 'CLOSE'
      IF NOT save_form('closing the window')
        RETURN .F.
      ENDIF
      HIDE WINDOW (t_cWindow)

    CASE m.cEvent = 'UPDATE'
      * If changes have been made, ignore simple update events.
      * Note that this code depends on SET EXACT OFF.
      IF NOT (t_bChanges AND cEvent == 'UPDATE')
        IF save_form('selecting a new record')
          * Process Special event messages we support.
          IF '>' $ m.cEvent
            DO controls WITH SUBSTR(cEvent,AT('>',cEvent)+1)
          ELSE
            IF '-' $ m.cEvent
              GO VAL(SUBSTR(cEvent,AT('-',cEvent)+1))
            ENDIF
            DO load_form
            DO show_form
          ENDIF
        ENDIF
      ENDIF

    CASE m.cEvent = 'LAUNCH' OR m.cEvent = 'ACTIVATE'
      IF NOT WVISIBLE( m.t_cWindow )
        * Position newly created window(s) at last saved position.
        * SIZE must be manually adjusted, NOT from screen generator
        MODIFY WINDOW ( m.t_cWindow ) ;
                FONT 'MS Sans Serif',8 STYLE 'B';
                ICON FILE cardfile.ico ;
                AT m.t_nWinRow, m.t_nWinCol SIZE 30,96 ;
                COLOR RGB(,,,192,192,192)

        * Initialize the GET variable array.
        STORE '' TO t_aGETvars
        STORE 0 TO t_nTopBump, t_nBotBump, t_nCurObj

        * Load current record into GET variable array.
        DO load_form
      ENDIF

      * Issue GETS if this is first time, or another task cleared them
      ACTIVATE WINDOW (m.t_cWindow) NOSHOW
      IF OBJNUM( t_nTopBump, wRdLevel() ) = 0
        DO issue_gets

        * Object numbers have changed, so clear saved object number
        m.t_nCurObj = 0
      ELSE
        * If window was just re-opened, show the gets.
        IF NOT WVISIBLE(m.t_cWindow)
          SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
        ENDIF
      ENDIF

      * Set option buttons correctly
      DO set_buttons WITH m.t_bChanges
      ACTIVATE WINDOW (m.t_cWindow)

      * If no saved object, determine default first object to read.
      IF m.t_nCurObj = 0
        m.t_nCurObj = OBJNUM( t_cField, wRdLevel() )
      ENDIF

      * Define flag to remember the state of our menu pad. The
      * Activate clause is re-called each time a dialog window
      * is closed. By using this flag we can avoid the overhead of
      * re-redefining our menu in these cases.
      bMenuUp = .F.

      * Give ZZProc.prg our READ level validation expressions
      DO wReadInit WITH 'repl_deact()', 'get_valid()', ;
                        'save_form("closing the window")'

      READ CYCLE SAVE OBJECT m.t_nCurObj ;
         ACTIVATE repl_act() ;
         DEACTIVATE repl_deact() ;
         VALID READKEY(1) = 5     && Only terminate if deactivate

      m.t_nCurObj = _nCurObj      && Remember last data object
  ENDCASE

  * Save current context information
  m.t_cOrder = ORDER('zzRepl')    && Remember data table order
  m.t_nRecno = RECNO('zzRepl')    && and record number
  DO wSaveState WITH m.cTaskAlias

  IF NOT WVISIBLE(t_cWindow)
    * Close the tables we use. If other tasks use them, they will
    * reopen them as part of their context restoration.
    SELECT zzFilt
    USE
    SELECT zzRepl
    USE

    * Close associated browse window also, if open.,
    IF WEXIST('Mass_Replace_List')
      DEACTIVATE WINDOW 'Mass_Replace_List'
    ENDIF

    DO wDelTask WITH m.cTaskAlias
  ENDIF
  RETURN .T.

*******************************************************************
PROCEDURE issue_gets
*++
* The code for this procedure will be generated by GENSCRN.  It
* will issue all the @GETs for the screen.  We want the GET
* commands to be in a seperate procedure so we can call them
* conditionally from the task program setup code.
*--

* ! Important !
* Make sure the When statement for the "get" field "TopBump"
* contains the name of the last "get" field and
* "BotBump" contains the name of the first "get" field
* this will insure that the cursor cycles properly!!!!!
*

*       *********************************************************
*       *                                                         
*       *              ZZREPL/Windows Screen Layout               
*       *                                                         
*       *********************************************************
*

#REGION 1
@ 17.308,3.000 SAY "Replace Field:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 19.538,11.667 SAY "With:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 14.308,6.000 SAY "Description:" ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 0.000,0.167 GET t_nTopBump ;
	PICTURE "@*IVN " ;
	SIZE 1.000,1.167,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper(OBJNUM(t_cField) + 7)
@ 14.385,20.833 GET t_cDesc ;
	SIZE 1.000,26.833 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 17.154,20.333 GET t_cField ;
	PICTURE "@^" ;
	FROM _zzsmast ;
	SIZE 1.538,27.500 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 19.615,20.833 GET t_cWith ;
	SIZE 1.000,26.500 ;
	DEFAULT " " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	PICTURE "@K XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 0.000,1.333 GET t_nBotBump ;
	PICTURE "@*IVN " ;
	SIZE 1.077,0.833,1.000 ;
	DEFAULT 0 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wBumper( OBJNUM(t_cField) )
@ 1.000,2.000 GET t_cOption ;
	PICTURE "@*BHN " + ;
		(LOCFILE("prev.bmp","BMP|ICO|PCT|ICN","Where is prev?")) + ";" + ;
		(LOCFILE("next.bmp","BMP|ICO|PCT|ICN","Where is next?")) + ";" + ;
		(LOCFILE("list.bmp","BMP|ICO|PCT|ICN","Where is list?")) + ";" + ;
		(LOCFILE("add.bmp","BMP|ICO|PCT|ICN","Where is add?")) + ";" + ;
		(LOCFILE("execute.bmp","BMP|ICO|PCT|ICN","Where is execute?")) + ";" + ;
		(LOCFILE("undo.bmp","BMP|ICO|PCT|ICN","Where is undo?")) + ";" + ;
		(LOCFILE("save.bmp","BMP|ICO|PCT|ICN","Where is save?")) + ";" + ;
		(LOCFILE("exit.bmp","BMP|ICO|PCT|ICN","Where is exit?")) ;
	SIZE 2.923,8.833,0.667 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	VALID ProcOption(t_cOption,.T.)
@ 5.154,1.833 SAY "This window allows you to replace a chosen customer field with a specific value." ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 7.538,2.000 SAY 'For Example: If you want to replace the field "Next Action" with "Send Letter" for' + CHR(13) + ;
		'customers in California, you would enter:' + CHR(13) + ;
		'' + CHR(13) + ;
		'Replace Field -> "Next Action"    With  -> "Send Letter"' + CHR(13) + ;
		'And select a filter where "State = CA" from the filter list.' ;
	SIZE 5.000,77.000, 0.000 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 22.692,3.000 SAY "Replace Records Where:...  (List Defined in Filter Window, Blank = All Records) " ;
	FONT "MS Sans Serif", 8 ;
	STYLE "BT"
@ 22.308,1.167 TO 22.308,81.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 22.308,1.167 TO 24.154,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 22.308,81.333 TO 24.000,81.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 24.000,1.333 TO 24.000,81.666 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 24.769,1.667 TO 24.769,81.500 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 24.769,1.333 TO 27.384,1.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 27.385,1.667 TO 27.385,81.334 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 24.846,81.333 TO 27.384,81.333 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 25.308,2.500 GET t_cFiltDsc ;
	PICTURE "@^" ;
	FROM _zzFilt ;
	SIZE 1.538,77.333 ;
	DEFAULT 1 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B" ;
	WHEN wGetWhen( "" ) ;
	VALID wGetValid( MDOWN() )
@ 28.308,1.833 SAY IIF(_Ok2All,'','For: Owner = [' +_Owner + ']' ) ;
	SIZE 1.000,33.333 ;
	FONT "MS Sans Serif", 8 ;
	STYLE "B"
@ 4.692,1.167 TO 4.692,81.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.692,1.167 TO 6.538,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 4.692,81.333 TO 6.384,81.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 6.385,1.333 TO 6.385,81.666 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 4.077,1.500 TO 4.077,78.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 0.692,1.500 TO 0.692,77.833 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,1.167 TO 4.154,1.167 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 0.692,77.833 TO 4.077,77.833 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.000,1.167 TO 7.000,81.500 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.000,1.167 TO 13.077,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 7.077,81.333 TO 12.923,81.333 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 12.923,1.333 TO 12.923,81.666 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 13.923,1.167 TO 13.923,17.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.923,1.167 TO 15.769,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.923,17.667 TO 15.615,17.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 15.615,1.333 TO 15.615,18.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 13.923,19.833 TO 13.923,49.166 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 13.923,19.500 TO 15.846,19.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 15.769,19.667 TO 15.769,49.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 13.923,49.000 TO 15.769,49.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 16.923,1.167 TO 16.923,17.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 16.923,1.167 TO 18.769,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 16.923,17.667 TO 18.615,17.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 18.615,1.333 TO 18.615,18.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 16.923,19.833 TO 16.923,49.166 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 16.923,19.500 TO 18.846,19.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 18.769,19.667 TO 18.769,49.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 16.923,49.000 TO 18.769,49.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.154,1.167 TO 19.154,17.834 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.154,1.167 TO 21.000,1.167 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.154,17.667 TO 20.846,17.667 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 20.846,1.333 TO 20.846,18.000 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.154,19.833 TO 19.154,49.166 ;
	PEN 2, 8 ;
	STYLE "1" ;
	COLOR RGB(128,128,128,128,128,128)
@ 19.154,19.500 TO 21.077,19.500 ;
	PEN 2, 8 ;
	COLOR RGB(128,128,128,128,128,128)
@ 21.000,19.667 TO 21.000,49.000 ;
	PEN 1, 8 ;
	STYLE "1" ;
	COLOR RGB(255,255,255,255,255,255)
@ 19.154,49.000 TO 21.000,49.000 ;
	PEN 1, 8 ;
	COLOR RGB(255,255,255,255,255,255)


*       *********************************************************
*       *                                                         
*       *               ZZREPL/Windows Cleanup Code               
*       *                                                         
*       *********************************************************
*

#REGION 1
********************************************************************


*       *********************************************************
*       *                                                         
*       *   ZZREPL/Windows Supporting Procedures and Functions    
*       *                                                         
*       *********************************************************
*

#REGION 1
FUNCTION repl_act
*++
* Task specific READ activation handler.
*--

  * Put up custom menu pad for this task window. The activate clause
  * may sometimes be called after the window is hidden during a close
  * operation, if a dialog box was activated by the form level
  * validation handler. The WVISIBLE() test makes sure we don't put
  * the menu back up in this case. The bMenuUp flag is used only for
  * optimization purposes - so we don't redefine the menu if it's
  * already there.
  IF WVISIBLE(m.t_cWindow) AND NOT bMenuUp
    DO zzrepl.mpr
    bMenuUp = .T.
  ENDIF

  RETURN .T.


********************************************************************
FUNCTION repl_deact
*++
* Task specific READ deactivation handler.
* This routine may be called by the READ command on a READ window
* deactivation, or explicitly by the wClearRead() function. That
* means we cannot depend on WLAST() or WONTOP() to be set right.
*--
  * Under FoxPro for Windows, Minimizing a window from the window
  * control box, or Choosing Next Window, bypasses the GET Valid
  * clause. This is our only chance to catch it, and thereby enforce
  * proper field validation.
  IF wCatchAll(m.t_cWindow)
    * Save last position of window
    m.t_nWinRow = WLROW(m.t_cWindow)
    m.t_nWinCol = WLCOL(m.t_cWindow)

    RELEASE PAD replace OF _MSYSMENU
    RELEASE POPUP replace
    bMenuUp = .F.
    RETURN .T.
  ELSE
    RETURN .F.
  ENDIF


********************************************************************
FUNCTION GET_valid
*++
* Common validation routine called when any field data is changed.
*
* This routine is responsible for:
*  1. Checking lock status of record, locking if needed.
*  2. Setting changes flag and setting buttons.
*
* Returns TRUE.
*  If data was changed and lock could not be established, data is
*  reset to initial value.
*--
PRIVATE xTemp

  IF NOT m.t_bchanges AND wChanged()
    IF NOT wLock(m.cTaskAlias, 'zzrepl', RECNO('zzrepl') )
      * Restore original field contents on Lock failure.
      DO wFldUndo

      * Return success, since user is warned, and changes undone.
      RETURN .T.
    ENDIF

    * Make sure any changes to record made since original
    * display are shown on screen when the record is locked.
    STORE EVALUATE( VARREAD() ) TO m.xTemp
    DO load_form
    STORE m.xTemp TO ( VARREAD() )
    DO show_form

    DO set_buttons WITH .T.
  ENDIF

  RETURN .T.


********************************************************************
PROCEDURE load_form
*++
* Load data from current record for display and/or edit.
*---
  SELECT zzrepl

  * Don't stay at EOF if we can help it.
  IF EOF()
    GOTO BOTTOM

    * If still at EOF, perform implicit add record command.
    IF EOF()
      RETURN init_form()
    ENDIF
  ENDIF

  m.t_bAddNew = .F.
  DO set_buttons WITH .F.

  * Let all the other tasks know what record we have displayed.
  DO wListen WITH m.cTaskAlias, 'zzrepl', RECNO('zzrepl')

  * Load data from field variables into GET variable array.
  SCATTER TO t_aGETvars MEMO
  RETURN


********************************************************************
PROCEDURE init_form
*++
* Initialize internal memory for a new address record.
* Let format default to current setting on add.
*---
  m.t_bAddNew = .T.
  DO set_buttons WITH .T.

  SELECT zzrepl
  SCATTER TO t_aGETvars MEMO BLANK

  * Move to first field to begin entry of new record.
  _CUROBJ = OBJNUM( t_cField )
  RETURN


********************************************************************
PROCEDURE show_form
*++
* Display current data and Enable/Disable fields as appropriate.
*---

  SHOW GETS WINDOW (m.t_cWindow) LEVEL wRdLevel()
  RETURN


********************************************************************
FUNCTION set_buttons
PARAMETER bChanges
*++
* Set changes flag, and update control buttons accordingly.
*--
PRIVATE nRecno

  IF m.bChanges
    SHOW GET t_cOption,6 ENABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 ENABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,6 DISABLE LEVEL wRdLevel()
    SHOW GET t_cOption,7 DISABLE LEVEL wRdLevel()
  ENDIF

  * The AddNEw flag will always be set if there are no records.
  IF t_bAddNew
    t_bAtTop = .T.
    t_bAtEnd = .T.
  ELSE
    nRecno = RECNO()
    SKIP -1
    t_bAtTop = BOF()
    GO nRecno

    SKIP 1
    t_bAtEnd = EOF()
    GO nRecno
  ENDIF

  * Set buttons according to current record
  IF m.t_bAtTop
    SHOW GET t_cOption,1 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,1 ENABLE LEVEL wRdLevel()
  ENDIF

  IF m.t_bAtEnd
    SHOW GET t_cOption,2 DISABLE LEVEL wRdLevel()
  ELSE
    SHOW GET t_cOption,2 ENABLE LEVEL wRdLevel()
  ENDIF

  * Store new value of task level change flag and return it.
  m.t_bChanges = m.bChanges
  RETURN m.bChanges


********************************************************************
FUNCTION ProcOption
PARAMETER cOption, bInObject
*++
* Process menu and pushbutton options.
*--

* place chosen filter into report filter memvar
SELECT zzFilt
IF NOT EMPTY(t_cFiltDsc)

  SEEK UPPER(t_cFiltDsc)

  * Limit user to "owned" records if required

  * Add something like [owner='JFK' AND ]
  * to the begining of the filter string
  * if limiting user access to not all records

  IF _Ok2All
    t_cFilt = zzFilt->FiltStr
  ELSE
    t_cFilt = 'owner=[' +_Owner + '] AND ' + ALLTRIM(zzFilt->FiltStr)
    * disable "Owner = " display on reports, pds 12/94
    * un-comment to enable!
    *t_cFiltDsc = '( Owner = ' + _Owner + ') ' + ALLTRIM(qFiltList)
  ENDIF

ELSE
    IF _Ok2All
      t_cFilt = ''
    ELSE
      t_cFilt = 'owner=[' +_Owner + ']'
      * disable "Owner = " display on reports, pds 12/94
      * un-comment to enable!
      *t_cFiltDsc = '( Owner = ' + _Owner + ') '
    ENDIF
ENDIF

* if choice is picture button, strip off ".BMP" from end
* make sure .bmp button file names match menu options!
m.cOption = STRTRAN(m.cOption,'.BMP','')
* identify file name, strip off path + back-slashes
m.cOption = SUBSTR(m.cOption,RAT('\',m.cOption)+1)

SELECT zzrepl
m.cOption = UPPER( ALLTRIM(m.cOption) )

  IF  m.cOption = 'COPY'
    APPEND BLANK
    GATHER FROM t_aGETvars MEMO
    DO load_form
    DO show_form
    DO wUnlock WITH m.cTaskAlias
    WAIT 'Record Copied' Window NOWAIT
    RETURN .T.
  ENDIF

  DO CASE

  * First, handle the common task button options.
  CASE controls(cOption, bInObject)

  CASE m.cOption = 'EXECUTE'
    DO ReplExe

  CASE m.cOption = 'LIST'
    * Launch an independant BROWSE window, linked to ours.
    DO wLaunch WITH 'ReplList IN zzRepl'

  ENDCASE

  RETURN .T.


********************************************************************
PROCEDURE ReplList
PARAMETER cEvent, cTaskAlias
*++
* This BROWSE task is designed to work together with the
* filter update task window.
*
* Parameters from wLaunch are ignored for BROWSE tasks, since
* once they are started, we never get control of them again.
*--
  SELECT zzrepl

  * Define a window for Browse to pattern itself after. Specify font
  * so size will be consistent even if Main Window font changes.
  DEFINE WINDOW bwin AT 1,1 SIZE 11,75 ;
                        FONT 'MS Sans Serif',8 STYLE 'B' ;
                        FLOAT SHADOW CLOSE MINIMIZE ZOOM ;
                        SYSTEM GROW COLOR SCHEME 8
  MOVE WINDOW bwin CENTER

  * Activate the BROWSE window. The WHEN clause calls zzrepl.prg
  * with the event string 'UPDATE-n' where n is the new
  * record number to display in the window.
  BROWSE NOWAIT REST NOMENU NOMODIFY ;
         WINDOW bwin TITLE 'Mass_Replace_List' ;
         FIELDS Desc,Field,With ;
         WHEN EVALUATE( 'zzrepl' ;
                + '("UPDATE-' + ALLTRIM(STR(RECNO())) ;
                + '", "1_ZZrepl")' )

  RELEASE WINDOW bwin
  RETURN


********************************************************************
FUNCTION save_form
PARAMETER cMsgTxt
*++
* Validate complete form as a whole, and save changes. If cMsgTxt
* contains a string, use it to ask whether or not user wants to
* save changes.
*--
PRIVATE nBadField, cReason, cAnswer

  SELECT zzrepl
  STORE '' TO m.cReason

  IF m.t_bChanges
    m.cAnswer = IIF(EMPTY(m.cMsgTxt), 'YES', zzQuest(m.t_cWindow, ;
        'Do you want to this mass replace description ' ;
        + 'before ' + m.cMsgTxt + '?' ) )

    * Return failure immediately if user cancels.
    IF m.cAnswer = 'CANCEL'
      RETURN .F.
    ENDIF

    * Save the changes if we are supposed to.
    IF m.cAnswer = 'YES'
      * Make sure all required fields have been entered.
      * none as of 9/94 pds
      *DO CASE
       *CASE EMPTY(t_cxxxxx)
       *  m.cReason = 'A xxxx is required'
       *  m.nBadField = OBJNUM(t_cxxx)
       *
      *ENDCASE

      IF NOT EMPTY(m.cReason)
        DO zzWarn WITH m.t_cWindow, m.cReason

        * This routine may be called when no GETs are issued (like
        * during Global shutdown). OBJNUM() returns 0 in this case.
        _CUROBJ = nBadField
        RETURN .F.
      ENDIF

      * Add a new record to the database when needed.
      IF m.t_bAddNew
        * Create new record
        APPEND BLANK
        m.t_bAddNew = .F.
      ENDIF

      GATHER FROM t_aGETvars MEMO
      DO set_buttons WITH .F.
    ELSE
      * User said 'dont save', so reload from disk.
      DO load_form
      DO show_form
    ENDIF

    * Whether changes saved or discarded, release the locks.
    DO wUnlock WITH m.cTaskAlias

  ENDIF

  RETURN .T.


* EOF - save_form
********************************************************************
FUNCTION ReplExe
* Execute mass replace
*


ON ERROR WAIT 'File in use, other users must quit SalesBridge, Press  <Enter>' WINDOW
IF NOT USED(_mastfile)
  * Use AGAIN in case another task, or BROWSE, has file open
  * under a different alias name.
  USE (LOCFILE(_mastfile,'DBF','Where is the customer master file?'));
      IN 0 AGAIN ALIAS &_mastfile EXCLUSIVE
ENDIF
ON ERROR DO zzerror WITH ERROR(),MESSAGE(),PROGRAM(),MESSAGE(1),LINENO(1)

IF NOT USED(_mastfile)
   WAIT 'Once users have quit, try again. Press <Enter>' WINDOW
   RETURN
ENDIF

SELECT &_MastFile
SET INDEX TO &_MastNdx

DEFINE WINDOW massrepl ;
  AT 4,7 ;
  SIZE 6,70 ;
  TITLE  'Mass Replace' ;
  FONT 'Times New Roman', 10 ;
  STYLE 'B' ;
  FLOAT ;
  CLOSE ;
  NOMINIMIZE ;
  DOUBLE
MOVE WINDOW massrepl CENTER
ACTIVATE WINDOW massrepl

* get mass replace filter "FOR" string

mRplFilt = t_cFilt

* Trim user entered values for filter statement
UsrFld   = ALLTRIM(t_cField)

mPos = ASCAN(_zzsmast,UsrFld)
mSub = ASUBSCRIPT(_zzsmast,mPos,1)

ReplFld = ALLTRIM(_zzsmast(mSub,2)) && the dbf field name
UsrType = _zzsmast(mSub,3)          && Field type
UsrLen  = _zzsmast(mSub,4)          && Field Length
UsrDec  = _zzsmast(mSub,5)          && Decimals, if numeric
*****

DO CASE
CASE UsrType = 'C'
  mWith = ALLTRIM(t_cWith)
CASE UsrType = 'N'
  mWith = VAL(t_cWith)
CASE UsrType = 'D'
  mWith = CTOD(ALLTRIM(t_cWith))
CASE UsrType = 'L'
  mWith = ALLTRIM(t_cWith)
OTHERWISE
  WAIT 'Mass replace can not be done on this field, Press <Enter>.' WINDOW
  DEACTIVATE WINDOW massrepl
  RETURN
ENDCASE

*WAIT replfld + ' WITH --'+t_cWith+'-- For --'+mrplfilt WINDOW
*DEACTIVATE WINDOW massrepl
*RETURN

*****

IF zzCntnue('Do you want to MASS REPLACE records?')
  * Continue
ELSE
  DEACTIVATE WINDOW MassRepl
  RETURN
ENDIF

SET TALK ON
SET ODOM TO 10

IF .NOT. EMPTY(mRplFilt)

  DO CASE
  CASE NOT EMPTY(t_cWith) .AND. NOT EMPTY(t_cField)
     REPLACE ALL &ReplFld WITH mWith FOR &mRplFilt
  OTHERWISE
     WAIT 'Fill in both FIELD and VALUE first. Press <Enter>' WINDOW
  ENDCASE

ELSE

  DO CASE
  CASE NOT EMPTY(t_cWith) .AND. NOT EMPTY(t_cField)
     REPLACE ALL &ReplFld WITH mWith
  OTHERWISE
     WAIT 'Fill in both FIELD and VALUE first. Press <Enter>' WINDOW
  ENDCASE

ENDIF

SET TALK OFF
SET ODOM TO 100

WAIT 'Mass Replace finished ' WINDOW TIMEOUT 2

DEACTIVATE WINDOW massrepl

RETURN

* EOF - ReplExe
********************************************************************
********************************************************************
********************************************************************
* EOF - zzRepl.prg